--This script will run on all levels when mod is active.
--Modding documentation: http://teardowngame.com/modding
--API reference: http://teardowngame.com/modding/api.html

muzzleflash = LoadSprite("gfx/glare.png")

function init()
	RegisterTool("ORIS Railgun", "ORIS Railgun", "MOD/Assets/Models/Railgun.vox",3)
	SetBool("game.tool.ORIS Railgun.enabled", true)
	SND = LoadSound("MOD/Assets/SFX/Fire.ogg")
	SND2 = LoadSound("MOD/Assets/SFX/Laser.ogg")
	SND3 = LoadSound("MOD/Assets/SFX/Charge.ogg")
	Ammo = 1
	Delay = 60
	Debug = false
	Stop_Count = false
	AmmoType = 1
	Power_lvl = 2
	Charge = 100
	recoil = 0
	LDelay = 0
	LCharge = 100
	RDelay = 8
	SetPwr = 1
	RemoveUi = false
	HideUi = false
	AimAmount = 0
	AimAmount2 = 0
	Pos = 0
	ldirection = 0
	SparkVel = 1
	hdist = 5
	StopHole = false
	StopSound = true
	HideImpact = false
	Count = 0
	StopCount = true
	SetLightPos = false
	LightSize = 3
end

function rnd(mi, ma)
	return math.random(0, 1000)/1000*(ma-mi)+mi
end

function tick()
	if Count > 0 then
		if SetLightPos then
			LightTransform = GetCameraTransform()
			SetLightPos = false
		end
                local fwd = TransformToParentVec(LightTransform, Vec(0, 0, -1))
                local maxDist = 50
                local hit, dist, normal, shape = QueryRaycast(LightTransform.pos, fwd, maxDist)
				SetValue("LightSize", 0, "linear", 2.8)
                if not hit then
                    dist = maxDist
                end

                --Laser line start and end points
                ---local s = VecAdd(VecAdd(LightTransform.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
                local s = TransformToParentPoint(LightTransform, Vec(0.575, -0.395, -1.2))
                local e = VecAdd(LightTransform.pos, VecScale(fwd, dist))

                --Draw laser line in ten segments with random offset
                local last = s
                for i=1, 10 do
                    local LightTransform = i/20
                    local p = VecLerp(s, e, LightTransform)
                    p = VecAdd(p, rndVec(0.2*LightTransform))
                    PointLight(last, 0.7, 0, 0, LightSize)
                    last = p
				end
	end
	PlayerVel = GetPlayerVelocity()
	if GetString("game.player.tool") == "ORIS Railgun" then
       SetBool("hud.aimdot", false)
            local attachmentPoint = Transform(VecScale(Vec(11.5, -8, 0), 0.05))
        --/ this line defines the laserlightTransform in world vec, done by translating the local vec inside the tool body out of the tool body
        local laserlightTransfrom=TransformToParentTransform(GetBodyTransform(GetToolBody()), attachmentPoint)
        --/ just in case its a nil, can remove this if statement if you want, its not needed
        if laserlightTransfrom~=nil then
            laserForwardTransform=TransformToParentVec(laserlightTransfrom,Vec(0,0,-1))
            hit,dist=QueryRaycast(laserlightTransfrom.pos,laserForwardTransform,500)
            pointpos=VecAdd(laserlightTransfrom.pos,VecScale(laserForwardTransform,dist))
            PointLight(pointpos, 1, 0.1, 0.07,.2)
            DrawLine(pointpos,laserlightTransfrom.pos, 1, 0.1, 0.07, .15)
        end
    end
	if Ammo == 1 and Charge >= 1 and not StopSound then
		local Pos = GetPlayerPos()
		PlaySound(SND3, Pos, 1)
		StopSound = true
	end
	if Charge > 0 and GetString("game.player.tool") == "ORIS Railgun" then
		muzzleEffect()
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("h") and GetPlayerVehicle() == 0 and GetBool("game.player.canusetool") then
		HideUi = (not HideUi)
	end
	if SetPwr == 4 then
		SetPwr = 1
		Power_lvl = 2
		HideImpact = false
	end
	if AmmoType == 4 then
		AmmoType = 1
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("p") and GetPlayerVehicle() == 0 and GetBool("game.player.canusetool") then
		AmmoType = (AmmoType + 1)
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("o") and GetPlayerVehicle() == 0 and GetBool("game.player.canusetool") then
		SetPwr = (SetPwr + 1)
		if SetPwr == 1 then
			Power_lvl = 2
			HideImpact = false
		end
		if SetPwr == 2 then
			Power_lvl = 4
			HideImpact = false
		end
		if SetPwr == 3 then
			HideImpact = true
			Power_lvl = 2
		end
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("f1") and GetPlayerVehicle() == 0 and GetBool("game.player.canusetool")  then
		Debug = (not Debug)
	end
	if Delay >= 0 and GetBool("game.player.canusetool") and GetString("game.player.tool") == "ORIS Railgun" and Ammo == 0 and Charge == 0 and not StopHole then
			beam()
			SparkVel = 1
			StopHole = true
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("lmb") and GetPlayerVehicle() == 0 and Ammo == 1 and Delay == 60 and Charge == 100 and GetBool("game.player.canusetool") then
			local Pos = GetPlayerPos()
			Ammo = 0
			Delay = 4
			RDelay = 8
			Stop_Count = false
			LCharge = 100
			Charge = 100
			ParticleReset()
			Beam = true
			PlaySound(SND, Pos, 1)
			else
			
			if GetString("game.player.tool") == "ORIS Railgun" and RDelay < 0 and GetPlayerVehicle() == 0 and Ammo == 0 then
				Ammo = 1
				StopHole = false
				StopSound = false
			end
	end
	--
	if GetString("game.player.tool") == "ORIS Railgun" and GetBool("game.player.canusetool") then
		local body = GetPlayerGrabBody()
			 local shape = GetPlayerGrabShape()
				if body == 0 and shape == 0 then
					local t = Transform()
					t.pos = Vec(AimAmount, AimAmount2, recoil/50)
					SetToolTransform(t)
				end
	end
	if GetString("game.player.tool") == "ORIS Railgun" and InputPressed("rmb") and GetBool("game.player.canusetool") then
			local body = GetPlayerGrabBody()
			 local shape = GetPlayerGrabShape()
				if body == 0 and shape == 0 then
					AimAmount = 0
					AimAmount2 = 0
					Aiming = true
					SetValue("AimAmount", -0.5755, "linear", 0.15)
					SetValue("AimAmount2", 0.15, "linear", 0.15)
				end
			end
	if GetString("game.player.tool") == "ORIS Railgun" and not InputDown("rmb") and GetBool("game.player.canusetool") then
					SetValue("AimAmount", 0, "linear", 0.15)
					SetValue("AimAmount2", 0, "linear", 0.15)
					Aiming = false
				end
	if Aiming then
		SetCameraFov(40)
	end
	if Ammo == 1 then
		LCharge = (LCharge + 3)
		Charge = math.floor(LCharge)
	end
	if Delay == 60 and Charge >= 100 then
		LCharge = 100
		Charge = 100
	end
end

function update(dt)
	if not StopCount then
		Count = (Count + dt)
	end
	if Count >= 2.8 then
		Count = 0
		StopCount = true
	end
	if Charge <= 0 or LCharge <= 0 then
		Charge = 0
		LCharge = 0
	end
	if Ammo == 0 then
		RDelay = (RDelay - dt)
	end
	if Ammo == 0 and not Stop_Count then
		Delay = (Delay - dt)
	end
	if Delay <= -0.23 then --0.23
		Delay = 60
		Stop_Count = true
	end
	if Debug then 
		DebugPrint(HideImpact)
		else
		if not Debug then
			--ClearChat()
		end
	end
	if Ammo == 0 then
		LDelay = math.floor(Delay)
		if LDelay == 0 then
			--recoil = 30
		end
		if Ammo == 0 and LCharge > 0 then
		Charge = math.floor(LCharge)
		LCharge = (LCharge - 0.43)
	end
	end
end
	
function draw(dt)
	if GetBool("game.player.canusetool") then
	if GetString("game.player.tool") == "ORIS Railgun" and GetPlayerVehicle() == 0 then
	local body = GetPlayerGrabBody()
			 local shape = GetPlayerGrabShape()
				if body == 0 and shape == 0 then
					UiPush()
						UiTranslate(UiCenter(), UiMiddle())
						UiAlign("center middle")
						if hit then
							UiColor(1,Charge/100,Charge/100, 0.55)
						end
						if not hit then
							UiColor(1,Charge/100,Charge/100, 0.2)
						end
						local x, y, dist = UiWorldToPixel(pointpos)
						if dist > 0 then
							UiTranslate(x, y)
						end
						if not InputDown("rmb") then
							UiScale(0.15)
							if InputDown("up") or InputDown("left") or InputDown("down") or InputDown("right") then
								UiScale(1.4)
							end
							UiImage("MOD/Assets/VFX/Crosshair.png")
						end
						if InputDown("rmb") then
							UiScale(0.75)
							UiImage("MOD/Assets/VFX/CrosshairAimed.png")
						end
					UiPop()
				end
		if not HideUi then
			UiPush()
				UiColor(0, 0, 0, 0.75)
				UiTranslate(-85,850)
				UiScale(0.55)
			UiImage("MOD/Assets/VFX/UiBox.png")
		UiPop()
		end
		if HideUi then
			UiPush()
				UiColor(0, 0, 0, 0.75)
				UiTranslate(-250,1025)
				UiScale(0.55)
			UiImage("MOD/Assets/VFX/UiBox.png")
		UiPop()
		end
		--Info
		if not HideUi then
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(348, 930)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Press  P  To Switch")
		UiPop()
		end
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(120, 1060)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			if not HideUi then
				UiText("Press  H  To Hide UI    ")
			end
			if HideUi then
				UiText("Press  H  To Show UI  ")
			end
		UiPop()
		--Charge
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(940, 980)
			UiFont("bold.ttf", 26)
			UiColor(1, 1, 1)
			if Charge == 0 and Ammo == 0 then
				UiColor(1, 0, 0)
			end
			UiText("Charge :")
		UiPop()
		--Charge Value
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(1005, 980)
			
			UiFont("bold.ttf", 26)	
			UiColor(1, 1, 1)
			if Charge == 0 and Ammo == 0 then
				UiColor(1, 0, 0)
			end
			UiText(Charge)
		UiPop()
		if not HideUi then
		--Power lvl
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(120, 900)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Railgun Strength :          ")
		UiPop()
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(120, 930)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Press  O  To Adjust         ")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(70, 960)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Normal")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(56, 990)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("High")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(60, 1020)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("            FPS Mode")
		UiPop()
		if SetPwr == 1 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(20, 960)
				UiFont("bold.ttf", 26)	
				UiColor(.5, .5, 1)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(70, 960)
				UiFont("bold.ttf", 26)	
				UiColor(.5, .5, 1)
				UiText("Normal")
			UiPop()
		end
		if SetPwr == 2 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(20, 990)
				UiFont("bold.ttf", 26)	
				UiColor(1, .25, .25)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(56, 990)
				UiFont("bold.ttf", 26)	
				UiColor(1, .25, .25)
				UiText("High")
			UiPop()
		end
		if SetPwr == 3 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(20, 1020)
				UiFont("bold.ttf", 26)	
				UiColor(.25, 1, .25)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(60, 1020)
				UiFont("bold.ttf", 26)	
				UiColor(.25, 1, .25)
				UiText("            FPS Mode")
			UiPop()
		end
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(320, 900)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Ammo Type :")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(348, 960)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Kinetic                    ")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(356, 1020)
			UiFont("bold.ttf", 26)
			UiColor(.75, .75, .75)
			UiText("Explosive                  ")
		UiPop()
		
		UiPush()
			UiAlign("center middle")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(360, 990)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("Incendiary                  ")
		UiPop()
		if AmmoType == 1 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(260, 960)
				UiFont("bold.ttf", 26)	
				UiColor(.5, .5, 1)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(348, 960)
				UiFont("bold.ttf", 26)	
				UiColor(.5, .5, 1)
				UiText("Kinetic                    ")
			UiPop()
		end
		if AmmoType == 3 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(260, 1020)
				UiFont("bold.ttf", 26)	
				UiColor(1, .25, .25)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(356, 1020)
				UiFont("bold.ttf", 26)
				UiColor(1, .25, .25)
				UiText("Explosive                  ")
			UiPop()
		end
		if AmmoType == 2 then
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(260, 990)
				UiFont("bold.ttf", 26)	
				UiColor(1, .6, .25)
				UiText(">")
			UiPop()
			UiPush()
				UiAlign("center middle")
				UiTextOutline(0, 0, 0, 1, 0.1)
				UiTranslate(360, 990)
				UiFont("bold.ttf", 26)	
				UiColor(1, .6, .25)
				UiText("Incendiary                  ")
			UiPop()
		end
	end	end
	end
end

function animateRecoil()
	SetValue("recoil", 2500, "easeout", 0.1)
	local t = Transform()
	t.pos = Vec(AimAmount, AimAmount2, recoil/50)
	SetToolTransform(t)
	SetValue("recoil", 0, "bounce", 5)
end

--[[function ClearChat()
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
	DebugPrint(" ")
end]]

function RandomVector(magnitude)
    local x = Random()
    local y = Random()
    local z = Random()
    return Vec((x - 0.5) * 2 * magnitude, (y - 0.5) * 2 * magnitude, (z - 0.5) * 2 * magnitude)
end

function Random()
    return math.random(0, 1000) / 1000
end

function get_bodys(pos)
    local bods = QueryAabbBodies( VecAdd(pos, Vec(-2, -2, -2)), VecAdd(pos, Vec(2, 2, 2)))
    for i=1, #bods do
        local body = bods[i]
        local com = GetBodyCenterOfMass(body)
                local mass = GetBodyMass(body)
                local voxelCount = GetShapeVoxelCount(shape)
        local t = TransformToParentPoint(GetBodyTransform(body), com)
                rv1 = VecAdd(t, Vec(math.random(-1, 1), math.random(-1, 1), math.random(-1, 1)))
                if math.random(1,7) <= 4 then
                SpawnFire(rv1)
                end


        local fwd = TransformToParentVec(com, Vec(0, 0, -1))
            QueryRequire("physical")
                QueryRejectVehicle(vehicle)
        local hit, dist, normal, shape = QueryRaycast(t, fwd, .15)

    end
end

function rndFloat(mi, ma)
	return mi + (ma-mi)*(math.random(0, 1000000)/1000000.0)
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function sparksEffect(pos)
                ParticleReset()
                ParticleEmissive(1, 0, "easein")
                ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
                ParticleRadius(math.random(20, 30)*.001, 0, "smooth")
                ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
                ParticleTile(4)
                ParticleCollide(1)
                ParticleSticky(1)
                for i = 1, math.random(62, 204) do
                    local vel = VecScale(RandomVector(1), math.random(1,2))
                    SpawnParticle(pos, vel, 8)
                end
                                ParticleReset()
                ParticleEmissive(1, 0, "easein")
                ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
                ParticleRadius(math.random(15, 25)*.001, 0, "smooth")
                ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
                ParticleTile(4)
                ParticleCollide(0, 1, "easeout")
                ParticleSticky(1, .3)
                for i = 1, math.random(32, 64) do
                    local vel = VecScale(RandomVector(1), math.random(3,5))
                    SpawnParticle(pos, vel, 5)
                end
                ParticleReset()
                ParticleEmissive(1, 0, "easein")
                ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
                ParticleRadius(math.random(10, 20)*.001, 0, "smooth")
                ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
                ParticleTile(4)
                ParticleCollide(0, 1, "easeout")
                ParticleSticky(1, .3)
                     
                for i = 1, math.random(32, 64) do
                    local vel = VecScale(RandomVector(1), math.random(7,10))
                    SpawnParticle(pos, vel, 5)
                end
end

function beam()
	SetLightPos = true
	local Pos = GetPlayerPos()
	local transform = GetCameraTransform()
	local origin = transform.pos
	local direction = QuatRotateVec(transform.rot, Vec(0, 0, -1))
	local hit, distance = QueryRaycast(origin, direction, 1000)
	local hit_pos = VecAdd(origin, VecScale(direction, distance))
            local t = GetCameraTransform()
			 if hit and distance < 1000 then
                hdist = distance
            end
			if InputDown("rmb")  then
				Bpos = TransformToParentPoint(t, Vec(0, -0.245, -0.2))
			end
			if not InputDown("rmb") then
                Bpos = TransformToParentPoint(t, Vec(0.575, -0.395, -0.2))
            end
            local dir = TransformToParentVec(t, Vec(0, 0, -1))
            local hit, dist = QueryRaycast(Bpos, dir, 1000)
            hit_P, dist_P = hit, dist
            local hitpoint1 = VecAdd(Bpos, VecScale(dir, dist))
            local hitpoint2 = VecAdd(Bpos, VecScale(dir, dist-0.8))
            local hitpoint3 = VecAdd(Bpos, VecScale(dir, dist-1))
			PlaySound(SND2, Pos, 1)
			animateRecoil()
			MakeHole(VecAdd(hitpoint1, VecScale(dir, i)), Power_lvl, Power_lvl, Power_lvl)
			StopCount = false
			LightSize = 3
			if hit and distance < 1000 then
				if not HideImpact then
					Paint(hitpoint1, 2.75, "explosion")
				end
				p = TransformToParentPoint(t, Vec(0.575, -0.595, -2))
				PointLight(p, 0.7, 0, 0, 3)
				for i = 0,20,1 do
					if not HideImpact and AmmoType == 3 then
					impactEffect(VecAdd(p, VecScale(dir, i)), RandomVector(0.5))
					end
				end
				for i = 0, 40 do
					MakeHole(VecAdd(hitpoint1, VecScale(dir, i)), Power_lvl, Power_lvl, Power_lvl)
					---sparksEffect(VecAdd(hitpoint1, VecNormalize(VecScale(dir, i), RandomVector(0.5))))
					if not HideImpact or AmmoType == 3 then
						sparksEffect(VecAdd(hitpoint3, VecScale(dir, i)), RandomVector(0.5))
					end
					---sparksEffect(VecAdd(hitpoint1, VecNormalize(dir), RandomVector(0.5)))




					if AmmoType == 3 then
						Explosion(VecAdd(hitpoint1, VecScale(dir, i)), 1.37)
					end
					if AmmoType == 2 then	
						get_bodys(VecAdd(hitpoint1, VecScale(dir, i)))
					end
				end
			end
				if HideImpact then
					hdist = 250
					else
					if not HideImpact then
						hdist = distance+350
					end
				end
					for i3 = 0, hdist, 0.01 do --0.01
						ParticleCollide(0)
						ParticleTile(6)
						ParticleRadius(0.069, 0.01,"smooth")
						ParticleColor(math.random(0, 5) / 10, 0, 0, 0.3, 0.1, 0.07)
						ParticleEmissive(5,0.27)
						ParticleDrag(0.575)
						ParticleAlpha(0.6,0,"linear")
						ParticleGravity(0)
						SpawnParticle(VecAdd(Bpos, VecScale(dir, i3)), Vec(0, 0, 0), 3) --2.27
						    --fire 
end
end

function impactEffect(hitpoint1)
    
    --fire 
    local q = 1.0 
    local caliber = 50
        --- sparks
    local vel = 2
    for i=1, math.ceil(caliber)*4 do
        local v = VecAdd(Vec(0, vel, 0 ), rndVec(rndFloat(vel*0.5, vel*1.5)))
        local life = rndFloat(0, 1)
        life = life*life * 3
        ParticleReset()
        ParticleEmissive(5, 0, "easeout")
        ParticleGravity(-5)
        ParticleRadius(0.03, 0.0, "easein")
        ParticleColor(math.random(0, 5) / 10, 0, 0, 0.3, 0.1, 0.07)
        ParticleTile(5)
        SpawnParticle(hitpoint1, v, life)
    end
end

function muzzleSmoke(barrelPos,fwd)
	local fwdVel = VecNormalize(VecSub(barrelPos,fwd))
	local calibreCoef = 2.5 
	local q = 1.0

	--- smoke
		local life = rndFloat(0.2, 0.7)
		life = 0.5 + life*life*life * 0.7	
	local radius = calibreCoef*.1
		ParticleReset()
		ParticleType("smoke")
		ParticleTile(0)
		local startColour = math.random(0, 5) / 10, 0, 0, 0.3, 0.1, 0.07 
		local endColour =  1, 0, 1  
		ParticleColor(1, 0.45, 0.25, 0.4)
		ParticleRadius(math.random(0.5,1)*radius, math.random(1,3)*radius,"easeout")
		ParticleAlpha(1.0, 0.3,"easeout")
		ParticleGravity(1,-0.8,"easeout")
		ParticleDrag(1)
		ParticleEmissive(1, 0.1,"easeout")
		ParticleRotation(0.5, 0)
		ParticleStretch(0.8)
		ParticleCollide(0, 1, "constant", 0.05)

		SpawnParticle(hitpoint1, VecScale(fwdVel,1), life)
end

function muzzleEffect()
	local ParticleLife = 0.15
	local nozzle = VecAdd(TransformToParentPoint(toolTrans, Vec(0.380,-0.35,-1.8)), VecScale(GetPlayerVelocity(), 1.5*GetTimeStep()))
    local pp = TransformToParentPoint(GetCameraTransform(), Vec(0.380,-0.35,-1.8))
	--SpawnParticle("smoke", TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.3,-1.9)), VecAdd(VecScale(dir, 2), GetPlayerVelocity()), 0.25, 0.5)
    ParticleType("plain")
    ParticleTile(4)
    ParticleColor(1,Charge/100,Charge/100) --ParticleColor(1, 0.6, 0.4, 1, 0.3, 0.2)
    ParticleRadius(Charge/1250)
    ParticleEmissive(5,1)
	ParticleGravity(0)
	--
    SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.9)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.8)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.7)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.6)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.5)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.4)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.3)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.2)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.1)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	--
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.85)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.75)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.65)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.55)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.45)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.35)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.25)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody(b)), Vec(0.575,-0.4,-1.15)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), ParticleLife)
	--
	--[[ParticleReset()
    ParticleType("plain")
    ParticleTile(6)
    ParticleSticky(0, 0)
    ParticleRadius(0.0075, 0.0075)
    ParticleAlpha(1, 0)
    ParticleEmissive(5, 5)
    ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25) --ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25)
    ParticleGravity(-10)
    ParticleCollide(0)
    for i = 1, 8 do
		SpawnParticle(nozzle, Vec((math.random(-100,100)/100)*4,(math.random(-100,100)/100)*4, (math.random(-100,100)/100)*4), 3)
	end]]
end